<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Doubly-Linked Lists</TITLE>
<link href="suif1_96.html" rel=Next>
<link href="suif1_94.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_94.html">previous</A>, <A HREF="suif1_96.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC95" HREF="suif1_toc.html#TOC95">Doubly-Linked Lists</A></H2>
<P>
<A NAME="IDX672"></A>
<A NAME="IDX673"></A>

</P>
<P>
<A NAME="IDX674"></A>
<A NAME="IDX675"></A>
<A NAME="IDX676"></A>
<A NAME="IDX677"></A>
For some applications, especially those where it is necessary to
traverse lists in both directions, doubly-linked lists work much better
than singly-linked lists.  The <CODE>dlist</CODE> class provides doubly-linked
lists with the same interface as the generic lists.  See section <A HREF="suif1_92.html#SEC92">Generic Lists</A>.  Thus you can interchange these data structures without having
to rewrite your code.  The <CODE>dlist_e</CODE> elements are derived from the
generic list element class but they also include the backwards link
fields.  The <CODE>dlist_iter</CODE> iterator works like the standard
<CODE>glist_iter</CODE> iterator, and the <CODE>DECLARE_DLIST_CLASS</CODE> macro is
the same as the <CODE>DECLARE_LIST_CLASS</CODE> macro except that it produces
doubly-linked lists.  All of these things are implemented in the
<TT>`dlist.h'</TT> and <TT>`dlist.cc'</TT> files.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_94.html">previous</A>, <A HREF="suif1_96.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
